Index: LMDZ5/trunk/libf/dynlonlat_phylonlat/phylmd/etat0phys_netcdf.F90
===================================================================
--- LMDZ5/trunk/libf/dynlonlat_phylonlat/phylmd/etat0phys_netcdf.F90	(revision 2335)
+++ LMDZ5/trunk/libf/dynlonlat_phylonlat/phylmd/etat0phys_netcdf.F90	(revision 2336)
@@ -36,5 +36,6 @@
   USE ioipsl,             ONLY: flininfo, flinopen, flinget, flinclo
   USE assert_eq_m,        ONLY: assert_eq
-  USE dimphy
+  USE dimphy,             ONLY: klon
+  USE conf_dat_m,         ONLY: conf_dat2d
   USE phys_state_var_mod, ONLY: zmea, zstd, zsig, zgam, zthe, zpic, zval, z0m, &
     rlon, solsw, radsol, t_ancien, wake_deltat, wake_s,  rain_fall, qsol, z0h, &
@@ -51,18 +52,15 @@
   include "paramet.h"
   include "comgeom2.h"
-  include "comvert.h"
   include "comconst.h"
   include "dimsoil.h"
   include "temps.h"
-  include "comdissnew.h"
-  include "serre.h"
   include "clesphys.h"
   REAL, SAVE :: deg2rad
   REAL, SAVE, ALLOCATABLE :: tsol(:)
-!  REAL, SAVE, ALLOCATABLE :: rugo(:,:)  ! ??? COMPUTED BUT NOT USED ???
   INTEGER,            SAVE      :: iml_phys, jml_phys, llm_phys, ttm_phys, fid_phys
   REAL, ALLOCATABLE,  SAVE      :: lon_phys(:,:), lat_phys(:,:), levphys_ini(:)
-  CHARACTER(LEN=256), PARAMETER :: orofname="Relief.nc"
-  CHARACTER(LEN=256), PARAMETER :: title="RELIEF"
+  CHARACTER(LEN=256), PARAMETER :: orofname="Relief.nc", orogvar="RELIEF"
+  CHARACTER(LEN=256), PARAMETER :: phyfname="ECPHY.nc",  psrfvar="SP"
+  CHARACTER(LEN=256), PARAMETER :: qsolvar="CDSW",       tsrfvar="ST"
 
 
@@ -72,10 +70,12 @@
 !-------------------------------------------------------------------------------
 !
-SUBROUTINE etat0phys_netcdf(ib, masque, phis)
+SUBROUTINE etat0phys_netcdf(masque, phis)
 !
 !-------------------------------------------------------------------------------
 ! Purpose: Creates initial states
 !-------------------------------------------------------------------------------
-! Note: This routine is designed to work for Earth
+! Notes:  1) This routine is designed to work for Earth
+!         2) If masque(:,:)/=-99999., masque and phis are already known.
+!         Otherwise: compute it.
 !-------------------------------------------------------------------------------
   USE control_mod
@@ -84,13 +84,9 @@
   USE regr_lat_time_climoz_m, ONLY: regr_lat_time_climoz
   USE indice_sol_mod
-  USE conf_phys_m,    ONLY: conf_phys
-  USE exner_hyb_m,    ONLY: exner_hyb
-  USE exner_milieu_m, ONLY: exner_milieu
-  USE test_disvert_m, ONLY: test_disvert
-  USE grid_atob_m,    ONLY: grille_m
+  USE conf_phys_m, ONLY: conf_phys
+  USE init_ssrf_m, ONLY: start_init_subsurf
   IMPLICIT NONE
 !-------------------------------------------------------------------------------
 ! Arguments:
-  LOGICAL, INTENT(IN)    :: ib          !--- Barycentric interpolation
   REAL,    INTENT(INOUT) :: masque(:,:) !--- Land mask           dim(iip1,jjp1)
   REAL,    INTENT(INOUT) :: phis  (:,:) !--- Ground geopotential dim(iip1,jjp1)
@@ -99,18 +95,10 @@
   CHARACTER(LEN=256) :: modname="etat0phys_netcdf", fmt
   INTEGER            :: i, j, l, ji, iml, jml
-  REAL               :: phystep
+  LOGICAL            :: read_mask
+  REAL               :: phystep, dummy
   REAL, DIMENSION(SIZE(masque,1),SIZE(masque,2)) :: masque_tmp
   REAL, DIMENSION(klon)               :: sn, rugmer, run_off_lic_0, fder
   REAL, DIMENSION(klon,nbsrf)         :: qsolsrf, snsrf
   REAL, DIMENSION(klon,nsoilmx,nbsrf) :: tsoil
-
-!--- Local variables for sea-ice reading:
-  LOGICAL           :: read_mask
-  INTEGER           :: iml_lic, jml_lic, isst(klon-2)
-  INTEGER           :: fid, llm_tmp, ttm_tmp, itaul(1)
-  REAL, ALLOCATABLE :: dlon_lic(:), lon_lic(:,:), fraclic(:,:)
-  REAL, ALLOCATABLE :: dlat_lic(:), lat_lic(:,:)
-  REAL              :: date, lev(1), dummy
-  REAL              :: flic_tmp(SIZE(masque,1),SIZE(masque,2))
 
 !--- Arguments for conf_phys
@@ -132,5 +120,5 @@
   jml=assert_eq(SIZE(masque,2),SIZE(phis,2),TRIM(modname)//" jml")
 
-! Grid construction and miscellanous initializations.
+! Physics configuration
 !*******************************************************************************
   CALL conf_phys(  ok_journe, ok_mensuel, ok_instan, ok_hf, ok_LES,     &
@@ -145,18 +133,8 @@
                    read_climoz,                                         &
                    alp_offset)
-
   CALL phys_state_var_init(read_climoz)
 
-  co2_ppm0 = co2_ppm  !--- Initial atmospheric CO2 conc. from .def file
-
-  rlat(1) = pi/2.
-  DO j=2,jjm; rlat((j-2)*iim+2:(j-1)*iim+1)=rlatu(j);     END DO
-  rlat(klon) = - pi/2.
-  rlat(:)=rlat(:)*(180.0/pi)
-
-  rlon(1) = 0.0
-  DO j=2,jjm; rlon((j-2)*iim+2:(j-1)*iim+1)=rlonv(1:iim); END DO
-  rlon(klon) = 0.0
-  rlon(:)=rlon(:)*(180.0/pi)
+!--- Initial atmospheric CO2 conc. from .def file
+  co2_ppm0 = co2_ppm
 
 ! Compute ground geopotential, sub-cells quantities and possibly the mask.
@@ -174,9 +152,9 @@
     WHERE(1.-masque(:,:)<EPSFRA) masque(:,:)=1.
   END IF
- CALL gr_dyn_fi(1,iml,jml,klon,masque,zmasq) !--- Land mask to physical grid
+  CALL gr_dyn_fi(1,iml,jml,klon,masque,zmasq) !--- Land mask to physical grid
 
 ! Compute tsol and qsol on physical grid, knowing phis on 2D grid.
 !*******************************************************************************
-  CALL start_init_phys(rlonv, rlatu, rlonu, rlatv, ib, phis)
+  CALL start_init_phys(rlonu, rlatv, phis)
 
 ! Some initializations.
@@ -188,56 +166,7 @@
     CALL regr_lat_time_climoz(read_climoz)
 
-! Sub-surfaces initialization
-!*******************************************************************************
-!--- Read and interpolate on model T-grid soil fraction and soil ice fraction.
-  CALL flininfo("landiceref.nc", iml_lic, jml_lic, llm_tmp, ttm_tmp, fid)
-  ALLOCATE( lat_lic(iml_lic,jml_lic),lon_lic(iml_lic, jml_lic))
-  ALLOCATE(dlat_lic(jml_lic),       dlon_lic(iml_lic))
-  ALLOCATE( fraclic(iml_lic,jml_lic))
-  CALL flinopen("landiceref.nc", .FALSE., iml_lic, jml_lic, llm_tmp,  &
- &               lon_lic, lat_lic, lev, ttm_tmp, itaul, date, dt, fid)
-  CALL flinget(fid, 'landice', iml_lic, jml_lic, llm_tmp, ttm_tmp, 1,1, fraclic)
-  CALL flinclo(fid)
-  WRITE(lunout,*)'landice dimensions: iml_lic, jml_lic : ',iml_lic,jml_lic
-  IF(MAXVAL(lon_lic)>pi) lon_lic=lon_lic*pi/180. !--- Conversion to degrees
-  IF(MAXVAL(lat_lic)>pi) lat_lic=lat_lic*pi/180.
-  dlon_lic(:)=lon_lic(:,1)
-  dlat_lic(:)=lat_lic(1,:)
-  CALL grille_m(dlon_lic, dlat_lic, fraclic, rlonv(1:iim), rlatu, flic_tmp(1:iim,:) )
-  flic_tmp(iml,:)=flic_tmp(1,:)
-
-!--- To the physical grid
-  pctsrf(:,:) = 0.
-  CALL gr_dyn_fi(1, iml, jml, klon, flic_tmp, pctsrf(:,is_lic))
-
-!--- Adequation with soil/sea mask
-  WHERE(pctsrf(:,is_lic)<EPSFRA) pctsrf(:,is_lic)=0. 
-  WHERE(zmasq(:)<EPSFRA)         pctsrf(:,is_lic)=0.
-  pctsrf(:,is_ter)=zmasq(:)
-  DO ji=1,klon
-    IF(zmasq(ji)>EPSFRA) THEN 
-      IF(pctsrf(ji,is_lic)>=zmasq(ji)) THEN
-        pctsrf(ji,is_lic)=zmasq(ji)
-        pctsrf(ji,is_ter)=0.
-      ELSE
-        pctsrf(ji,is_ter)=zmasq(ji)-pctsrf(ji,is_lic)
-        IF(pctsrf(ji,is_ter)<EPSFRA) THEN
-          pctsrf(ji,is_ter)=0.
-          pctsrf(ji,is_lic)=zmasq(ji)
-        END IF 
-      END IF 
-    END IF 
-  END DO 
-
-!--- Sub-surface ocean and sea ice (sea ice set to zero for start).
-  pctsrf(:,is_oce)=(1.-zmasq(:))
-  WHERE(pctsrf(:,is_oce)<EPSFRA) pctsrf(:,is_oce)=0.
-  IF(read_mask) pctsrf(:,is_oce)=1-zmasq(:)
-  isst=0
-  WHERE(pctsrf(2:klon-1,is_oce)>0.) isst=1
-
-!--- It is checked that the sub-surfaces sum is equal to 1.
-  ji=COUNT((ABS(SUM(pctsrf(:,:),dim=2))-1.0)>EPSFRA)
-  IF(ji/=0) WRITE(lunout,*) 'Sub-cell distribution problem for ',ji,' points'
+! Sub-surfaces initialization.
+!*******************************************************************************
+  CALL start_init_subsurf(read_mask)
 
 ! Write physical initial state
@@ -321,6 +250,4 @@
 !   described in LOTT & MILLER (1997) and LOTT(1999).
 !===============================================================================
-  USE conf_dat_m,  ONLY: conf_dat2d
-!  USE grid_atob_m, ONLY: rugsoro
   USE grid_noro_m, ONLY: grid_noro
   IMPLICIT NONE
@@ -331,6 +258,5 @@
 !-------------------------------------------------------------------------------
 ! Local variables:
-  CHARACTER(LEN=256) :: modname="start_init_orog"
-  CHARACTER(LEN=256) :: title="RELIEF"
+  CHARACTER(LEN=256) :: modname
   INTEGER            :: fid, llm_tmp,ttm_tmp, iml,jml, iml_rel,jml_rel, itau(1)
   REAL               :: lev(1), date, dt
@@ -340,4 +266,5 @@
   REAL, ALLOCATABLE  :: zgam0(:,:), zthe0(:,:), zpic0(:,:), zval0(:,:)
 !-------------------------------------------------------------------------------
+  modname="start_init_orog"
   iml=assert_eq(SIZE(lon_in),SIZE(phis,1),SIZE(masque,1),TRIM(modname)//" iml")
   jml=assert_eq(SIZE(lat_in),SIZE(phis,2),SIZE(masque,2),TRIM(modname)//" jml")
@@ -350,5 +277,5 @@
                 lev, ttm_tmp, itau, date, dt, fid)
   ALLOCATE(relief_hi(iml_rel,jml_rel))
-  CALL flinget(fid, title, iml_rel, jml_rel, llm_tmp, ttm_tmp, 1, 1, relief_hi)
+  CALL flinget(fid, orogvar, iml_rel, jml_rel, llm_tmp, ttm_tmp, 1,1, relief_hi)
   CALL flinclo(fid)
 
@@ -360,5 +287,5 @@
 !--- FIELDS ARE PROCESSED TO BE ON STANDARD ANGULAR DOMAINS
   ALLOCATE(lon_rad(iml_rel),lat_rad(jml_rel))
-  CALL conf_dat2d(title, lon_ini, lat_ini, lon_rad, lat_rad, relief_hi, .FALSE.)
+  CALL conf_dat2d(orogvar, lon_ini, lat_ini, lon_rad, lat_rad, relief_hi,.FALSE.)
   DEALLOCATE(lon_ini,lat_ini)
 
@@ -378,12 +305,4 @@
   phis = phis * 9.81
   phis(iml,:) = phis(1,:)
-
-!--- COMPUTE SURFACE ROUGHNESS
-!  WRITE(lunout,*)
-!  WRITE(lunout,*)'*** Compute surface roughness induced by the orography ***'
-!  ALLOCATE(tmp_var(iml-1,jml))
-!  CALL rugsoro(lon_rad, lat_rad, relief_hi, lon_in(1:iml-1), lat_in, tmp_var)
-!  ALLOCATE(rugo(iml,jml)); rugo(1:iml-1,:)=tmp_var; rugo(iml,:)=tmp_var(1,:)
-!  DEALLOCATE(tmp_var)
   DEALLOCATE(relief_hi,lon_rad,lat_rad)
 
@@ -405,5 +324,5 @@
 !-------------------------------------------------------------------------------
 !
-SUBROUTINE start_init_phys(lon_in,lat_in,lon_in2,lat_in2,ibar,phis)
+SUBROUTINE start_init_phys(lon_in,lat_in,phis)
 !
 !===============================================================================
@@ -413,11 +332,9 @@
 !-------------------------------------------------------------------------------
 ! Arguments:
-  REAL,    INTENT(IN) :: lon_in (:),  lat_in (:)     ! dim (iml) (jml)
-  REAL,    INTENT(IN) :: lon_in2(:),  lat_in2(:)     ! dim (iml) (jml2)
-  LOGICAL, INTENT(IN) :: ibar
+  REAL,    INTENT(IN) :: lon_in(:),  lat_in(:)       ! dim (iml) (jml2)
   REAL,    INTENT(IN) :: phis(:,:)                   ! dim (iml,jml)
 !-------------------------------------------------------------------------------
 ! Local variables:
-  CHARACTER(LEN=256) :: modname="start_init_phys", physfname="ECPHY.nc"
+  CHARACTER(LEN=256) :: modname
   REAL               :: date, dt
   INTEGER            :: iml, jml, jml2, itau(1)
@@ -426,15 +343,15 @@
   REAL, ALLOCATABLE  :: ts(:,:), qs(:,:)
 !-------------------------------------------------------------------------------
-  iml=assert_eq(SIZE(lon_in),SIZE(phis,1),SIZE(lon_in2),TRIM(modname)//" iml")
-  jml=assert_eq(SIZE(lat_in),SIZE(phis,2),              TRIM(modname)//" jml")
-  jml2=SIZE(lat_in2)
+  modname="start_init_phys"
+  iml=assert_eq(SIZE(lon_in),SIZE(phis,1),TRIM(modname)//" iml")
+  jml=SIZE(phis,2); jml2=SIZE(lat_in)
 
   WRITE(lunout,*)'Opening the surface analysis'
-  CALL flininfo(physfname, iml_phys, jml_phys, llm_phys, ttm_phys, fid_phys)
-  WRITE(lunout,*) 'Values read: ',   iml_phys, jml_phys, llm_phys, ttm_phys
+  CALL flininfo(phyfname, iml_phys, jml_phys, llm_phys, ttm_phys, fid_phys)
+  WRITE(lunout,*) 'Values read: ',  iml_phys, jml_phys, llm_phys, ttm_phys
 
   ALLOCATE(lat_phys(iml_phys,jml_phys),lon_phys(iml_phys,jml_phys))
   ALLOCATE(levphys_ini(llm_phys))
-  CALL flinopen(physfname, .FALSE., iml_phys, jml_phys, llm_phys,              &
+  CALL flinopen(phyfname, .FALSE., iml_phys, jml_phys, llm_phys,              &
                 lon_phys,lat_phys,levphys_ini,ttm_phys,itau,date,dt,fid_phys)
 
@@ -445,6 +362,6 @@
 
   ALLOCATE(var_ana(iml_phys,jml_phys),lon_rad(iml_phys),lat_rad(jml_phys))
-  CALL get_var_phys('ST'  ,ts)                   !--- SURFACE TEMPERATURE
-  CALL get_var_phys('CDSW',qs)                   !--- SOIL MOISTURE
+  CALL get_var_phys(tsrfvar,ts)                   !--- SURFACE TEMPERATURE
+  CALL get_var_phys(qsolvar,qs)                   !--- SOIL MOISTURE
   CALL flinclo(fid_phys)
   DEALLOCATE(var_ana,lon_rad,lat_rad,lon_ini,lat_ini)
@@ -463,5 +380,4 @@
 !
 !-------------------------------------------------------------------------------
-  USE conf_dat_m, ONLY: conf_dat2d
   IMPLICIT NONE
 !-------------------------------------------------------------------------------
@@ -474,13 +390,13 @@
 !-------------------------------------------------------------------------------
   SELECT CASE(title)
-    CASE('SP');        tllm=0
-    CASE('ST','CDSW'); tllm=llm_phys
+    CASE(psrfvar);         tllm=0
+    CASE(tsrfvar,qsolvar); tllm=llm_phys
   END SELECT
   IF(ALLOCATED(field)) RETURN
   ALLOCATE(field(iml,jml)); field(:,:)=0.
   CALL flinget(fid_phys,title,iml_phys,jml_phys,tllm,ttm_phys,1,1,var_ana)
-  CALL conf_dat2d(title, lon_ini, lat_ini,  lon_rad, lat_rad, var_ana, ibar)
-  CALL interp_startvar(title, ibar, .TRUE., lon_rad, lat_rad, var_ana,         &
-                            lon_in, lat_in, lon_in2, lat_in2, field)
+  CALL conf_dat2d(title, lon_ini, lat_ini, lon_rad, lat_rad, var_ana, .TRUE.)
+  CALL interp_startvar(title, .TRUE., lon_rad, lat_rad, var_ana,               &
+                                      lon_in,  lat_in,  field)
 
 END SUBROUTINE get_var_phys
@@ -495,41 +411,35 @@
 !-------------------------------------------------------------------------------
 !
-SUBROUTINE interp_startvar(nam,ibar,ibeg,lon,lat,vari,lon1,lat1,lon2,lat2,varo)
+SUBROUTINE interp_startvar(nam,ibeg,lon,lat,vari,lon2,lat2,varo)
 !
 !-------------------------------------------------------------------------------
   USE inter_barxy_m, ONLY: inter_barxy
-  USE grid_atob_m,   ONLY: grille_m
   IMPLICIT NONE
 !-------------------------------------------------------------------------------
 ! Arguments:
   CHARACTER(LEN=*), INTENT(IN)  :: nam
-  LOGICAL,          INTENT(IN)  :: ibar, ibeg
+  LOGICAL,          INTENT(IN)  :: ibeg
   REAL,             INTENT(IN)  :: lon(:), lat(:)   ! dim (ii) (jj)
   REAL,             INTENT(IN)  :: vari(:,:)        ! dim (ii,jj)
-  REAL,             INTENT(IN)  :: lon1(:), lat1(:) ! dim (i1) (j1)
   REAL,             INTENT(IN)  :: lon2(:), lat2(:) ! dim (i1) (j2)
   REAL,             INTENT(OUT) :: varo(:,:)        ! dim (i1) (j1)
 !-------------------------------------------------------------------------------
 ! Local variables:
-  CHARACTER(LEN=256) :: modname="interp_startvar"
+  CHARACTER(LEN=256) :: modname
   INTEGER            :: ii, jj, i1, j1, j2
   REAL, ALLOCATABLE  :: vtmp(:,:)
 !-------------------------------------------------------------------------------
-  ii=assert_eq(SIZE(lon),            SIZE(vari,1),TRIM(modname)//" ii")
-  jj=assert_eq(SIZE(lat),            SIZE(vari,2),TRIM(modname)//" jj")
-  i1=assert_eq(SIZE(lon1),SIZE(lon2),SIZE(varo,1),TRIM(modname)//" i1")
-  j1=assert_eq(SIZE(lat1),           SIZE(varo,2),TRIM(modname)//" j1")
-  j2=SIZE(lat2)
+  modname="interp_startvar"
+  ii=assert_eq(SIZE(lon), SIZE(vari,1),TRIM(modname)//" ii")
+  jj=assert_eq(SIZE(lat), SIZE(vari,2),TRIM(modname)//" jj")
+  i1=assert_eq(SIZE(lon2),SIZE(varo,1),TRIM(modname)//" i1")
+  j1=SIZE(varo,2); j2=SIZE(lat2)
   ALLOCATE(vtmp(i1-1,j1))
-  IF(ibar) THEN
-    IF(ibeg.AND.prt_level>1) THEN
-      WRITE(lunout,*)"--------------------------------------------------------"
-      WRITE(lunout,*)"$$$ Interpolation barycentrique pour "//TRIM(nam)//" $$$"
-      WRITE(lunout,*)"--------------------------------------------------------"
-    END IF
-    CALL inter_barxy(lon, lat(:jj-1), vari, lon2(:i1-1), lat2, vtmp)
-  ELSE
-    CALL grille_m   (lon, lat,        vari, lon1,        lat1, vtmp)
+  IF(ibeg.AND.prt_level>1) THEN
+    WRITE(lunout,*)"--------------------------------------------------------"
+    WRITE(lunout,*)"$$$ Interpolation barycentrique pour "//TRIM(nam)//" $$$"
+    WRITE(lunout,*)"--------------------------------------------------------"
   END IF
+  CALL inter_barxy(lon, lat(:jj-1), vari, lon2(:i1-1), lat2, vtmp)
   CALL gr_int_dyn(vtmp, varo, i1-1, j1)
 
